> For the complete documentation index, see [llms.txt](https://docs.servoy.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.servoy.com/reference/servoyextensions/server-plugins/ai.md).

# AI

(plugins.ai)

## Overview

AIProvider class that provides access to create AI chat and embedding clients/builders.

## **Returned Types**

[ChatClient](/reference/servoyextensions/server-plugins/ai/chatclient.md),[GeminiChatBuilder](/reference/servoyextensions/server-plugins/ai/geminichatbuilder.md),[OpenAiChatBuilder](/reference/servoyextensions/server-plugins/ai/openaichatbuilder.md),[GeminiEmbeddingModelBuilder](/reference/servoyextensions/server-plugins/ai/geminiembeddingmodelbuilder.md),[OpenAiEmbeddingModelBuilder](/reference/servoyextensions/server-plugins/ai/openaiembeddingmodelbuilder.md),[ServoyEmbeddingStoreBuilder](/reference/servoyextensions/server-plugins/ai/servoyembeddingstorebuilder.md),[EmbeddingStore](/reference/servoyextensions/server-plugins/ai/embeddingstore.md),[EmbeddingModel](/reference/servoyextensions/server-plugins/ai/embeddingmodel.md),[ChatResponse](/reference/servoyextensions/server-plugins/ai/chatresponse.md),[SearchResult](/reference/servoyextensions/server-plugins/ai/searchresult.md),[ToolBuilder](/reference/servoyextensions/server-plugins/ai/toolbuilder.md),

## Methods Summarized

| Type                                                                                                        | Name                                                                          | Summary                                                                  |
| ----------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------- | ------------------------------------------------------------------------ |
| [GeminiChatBuilder](/reference/servoyextensions/server-plugins/ai/geminichatbuilder.md)                     | [createGeminiChatBuilder()](#creategeminichatbuilder)                         | Creates a builder for Gemini chat models.                                |
| [ChatClient](/reference/servoyextensions/server-plugins/ai/chatclient.md)                                   | [createGeminiClient(apiKey, modelName)](#creategeminiclient-apikey-modelname) | Creates a Gemini chat client using the provided API key and model name.  |
| [GeminiEmbeddingModelBuilder](/reference/servoyextensions/server-plugins/ai/geminiembeddingmodelbuilder.md) | [createGeminiEmbeddingModelBuilder()](#creategeminiembeddingmodelbuilder)     | Creates a builder for Gemini embeddings.                                 |
| [ChatClient](/reference/servoyextensions/server-plugins/ai/chatclient.md)                                   | [createOpenAIClient(apiKey, modelName)](#createopenaiclient-apikey-modelname) | Creates an OpenAI chat client using the provided API key and model name. |
| [OpenAiChatBuilder](/reference/servoyextensions/server-plugins/ai/openaichatbuilder.md)                     | [createOpenAiChatBuilder()](#createopenaichatbuilder)                         | Creates a builder for OpenAI chat models.                                |
| [OpenAiEmbeddingModelBuilder](/reference/servoyextensions/server-plugins/ai/openaiembeddingmodelbuilder.md) | [createOpenAiEmbeddingModelBuilder()](#createopenaiembeddingmodelbuilder)     | Creates a builder for OpenAI store.                                      |

## Methods Detailed

### createGeminiChatBuilder()

Creates a builder for Gemini chat models.

**Returns:** [GeminiChatBuilder](/reference/servoyextensions/server-plugins/ai/geminichatbuilder.md) GeminiChatBuilder instance.

### createGeminiClient(apiKey, modelName)

Creates a Gemini chat client using the provided API key and model name. This is a quick way to create a client without using the builder.

**Parameters**

* [String](/reference/servoycore/dev-api/js-lib/string.md) **apiKey** The Gemini API key.
* [String](/reference/servoycore/dev-api/js-lib/string.md) **modelName** The Gemini model name.

**Returns:** [ChatClient](/reference/servoyextensions/server-plugins/ai/chatclient.md) ChatClient instance for Gemini.

### createGeminiEmbeddingModelBuilder()

Creates a builder for Gemini embeddings.

**Returns:** [GeminiEmbeddingModelBuilder](/reference/servoyextensions/server-plugins/ai/geminiembeddingmodelbuilder.md) GeminiEmbeddingModelBuilder instance.

### createOpenAIClient(apiKey, modelName)

Creates an OpenAI chat client using the provided API key and model name. This is a quick way to create a client without using the builder.

**Parameters**

* [String](/reference/servoycore/dev-api/js-lib/string.md) **apiKey** The OpenAI API key.
* [String](/reference/servoycore/dev-api/js-lib/string.md) **modelName** The OpenAI model name.

**Returns:** [ChatClient](/reference/servoyextensions/server-plugins/ai/chatclient.md) ChatClient instance for OpenAI.

### createOpenAiChatBuilder()

Creates a builder for OpenAI chat models.

**Returns:** [OpenAiChatBuilder](/reference/servoyextensions/server-plugins/ai/openaichatbuilder.md) OpenAiChatBuilder instance.

### createOpenAiEmbeddingModelBuilder()

Creates a builder for OpenAI store.

**Returns:** [OpenAiEmbeddingModelBuilder](/reference/servoyextensions/server-plugins/ai/openaiembeddingmodelbuilder.md) OpenAiEmbeddingModelBuilder instance.

***


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.servoy.com/reference/servoyextensions/server-plugins/ai.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
